## visad.java3d
Class ShadowFunctionOrSetTypeJ3D

    java.lang.Object
      visad.ShadowType
          visad.java3d.ShadowTypeJ3D
              visad.java3d.ShadowFunctionOrSetTypeJ3D

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  ShadowFunctionTypeJ3D, ShadowSetTypeJ3D

public class ShadowFunctionOrSetTypeJ3D
extends ShadowTypeJ3D

The ShadowFunctionOrSetTypeJ3D is an abstract parent for ShadowFunctionTypeJ3D and ShadowSetTypeJ3D.

See Also:
  Serialized Form

Field Summary
`(package private) ShadowRealTupleTypeJ3D` `Domain`
`(package private) ShadowTypeJ3D` `Range`

Fields inherited from class visad.java3d.ShadowTypeJ3D
`adaptedShadowType, display, inheritedText, inheritedTextControl, Link, projListener, Type`

Fields inherited from class visad.ShadowType
`LEGAL, METERS_PER_DEGREE, NESTED, NOTHING_MAPPED, SIMPLE_ANIMATE_FIELD, SIMPLE_FIELD, SIMPLE_TUPLE`

Constructor Summary
`ShadowFunctionOrSetTypeJ3D(MathType t, DataDisplayLink link, ShadowType parent)`

Method Summary
`void` `addSwitch(Object group, Object swit, Control control, Set domain_set, DataRenderer renderer)`
`void` `addToGroup(Object group, Object branch)`
`void` `addToSwitch(Object swit, Object branch)`
`void` `adjustZ(float[] coordinates)`
`boolean` `doTransform(Object group, Data data, float[] value_array, float[] default_values, DataRenderer renderer)` transform data into a Java3D scene graph; add generated scene graph components as children of group; value_array are inherited valueArray values; default_values are defaults for each display.DisplayRealTypeVector; return true if need post-process
`ShadowRealTupleTypeJ3D` `getDomain()`
`ShadowTypeJ3D` `getRange()`
`Vector` `getTextMaps(int i, int[] textIndices)`
`Object` `makeBranch()`
`javax.media.j3d.GeometryArray[]` `makeGeometrys(VisADGeometryArray array)`
`Object` `makeSwitch()`
`VisADGeometryArray[]` `makeVisADGeometrys(VisADGeometryArray array)`
`void` `postProcess(Object group)` render accumulated Vector of value_array-s to and add to group; then clear AccumulationVector
`void` `preProcess()` clear AccumulationVector
`boolean` `recurseRange(Object group, Data data, float[] value_array, float[] default_values, DataRenderer renderer)`
`float[]` `setTex3DCoords(int length, int axis, float ratiow, float ratioh, float ratiod)`
`void` `setTexCoords(float[] texCoords, float ratiow, float ratioh)`
`float[]` `setTexStackCoords(int length, int axis, float ratiow, float ratioh, float ratiod)`
`void` `texture3DToGroup(Object group, VisADGeometryArray arrayX, VisADGeometryArray arrayY, VisADGeometryArray arrayZ, VisADGeometryArray arrayXrev, VisADGeometryArray arrayYrev, VisADGeometryArray arrayZrev, BufferedImage[] images, GraphicsModeControl mode, float constant_alpha, float[] constant_color, int texture_width, int texture_height, int texture_depth, DataRenderer renderer)`
`int` `textureDepth(int data_depth)`
`int` `textureHeight(int data_height)`

`void`

`textureStackToGroup(Object group, VisADGeometryArray arrayX, VisADGeometryArray arrayY, VisADGeometryArray arrayZ, VisADGeometryArray arrayXrev, VisADGeometryArray arrayYrev, VisADGeometryArray arrayZrev, BufferedImage[] imagesX, BufferedImage[] imagesY, BufferedImage[] imagesZ, GraphicsModeControl mode, float constant_alpha, float[] constant_color, int texture_width, int texture_height, int texture_depth, DataRenderer renderer)`

`void` `textureToGroup(Object group, VisADGeometryArray array, BufferedImage image, GraphicsModeControl mode, float constant_alpha, float[] constant_color, int texture_width, int texture_height)`
`int` `textureWidth(int data_width)`
`boolean` `wantIndexed()`

Methods inherited from class visad.java3d.ShadowTypeJ3D

`addLabelsToGroup, addTextToGroup, addToGroup, allowConstantColorSurfaces, assembleColor, assembleFlow, assembleSelect, assembleShape, assembleSpatial, checkIndices, ensureNotEmpty, ensureNotEmpty, getAdaptedParent, getAdaptedShadowType, getComponents, getData, getDisplay, getDisplayIndices, getLevelOfDifficulty, getMappedDisplayScalar, getMultipleDisplayScalar, getParentText, getParentTextControl, getType, getValueIndices, makeAppearance, makeContour, makeFlow, makePointGeometry, makeStreamline, makeText, mapValues, mapValues, mapValues, setText, staticMakeAppearance, terminalTupleOrScalar, toString`

Methods inherited from class visad.ShadowType

`adjustFlowToEarth, allowCurvedTexture, allowLinearContour, byteToFloat, floatToByte, getAdjustProjectionSeam, getAnyContour, getAnyFlow, getAnyShape, getAnyText, getComponentIndex, getComponentWithRef, getCurvedTexture, getDefaultColorIndex, getIsLinearContour3D, getIsTerminal, getIsTexture3D, getIsTextureMap, getLink, getMultipleSpatialDisplayScalar, getRefToComponent, makePointGeometry, makeSpatialSet, recurseComponent, terminalTupleOrScalar`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### Domain

    ShadowRealTupleTypeJ3D Domain

### Range

    ShadowTypeJ3D Range

Constructor Detail

### ShadowFunctionOrSetTypeJ3D

    public ShadowFunctionOrSetTypeJ3D(MathType t,
                                      DataDisplayLink link,
                                      ShadowType parent)
                               throws VisADException,
                                      RemoteException

Method Detail

### getDomain

    public ShadowRealTupleTypeJ3D getDomain()

### getRange

    public ShadowTypeJ3D getRange()

### preProcess

    public void preProcess()
                    throws VisADException

  clear AccumulationVector

  Overrides:
    `preProcess` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`

### doTransform

    public boolean doTransform(Object group,
                               Data data,
                               float[] value_array,
                               float[] default_values,
                               DataRenderer renderer)
                        throws VisADException,
                               RemoteException

  transform data into a Java3D scene graph; add generated scene graph components as children of group; value_array are inherited valueArray values; default_values are defaults for each display.DisplayRealTypeVector; return true if need post-process

  Overrides:
    `doTransform` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`
    `RemoteException`

### textureWidth

    public int textureWidth(int data_width)

  Overrides:
    `textureWidth` in class `ShadowType`

### textureHeight

    public int textureHeight(int data_height)

  Overrides:
    `textureHeight` in class `ShadowType`

### textureDepth

    public int textureDepth(int data_depth)

  Overrides:
    `textureDepth` in class `ShadowType`

### adjustZ

    public void adjustZ(float[] coordinates)

  Overrides:
    `adjustZ` in class `ShadowType`

### setTexCoords

    public void setTexCoords(float[] texCoords,
                             float ratiow,
                             float ratioh)

  Overrides:
    `setTexCoords` in class `ShadowType`

### setTex3DCoords

    public float[] setTex3DCoords(int length,
                                  int axis,
                                  float ratiow,
                                  float ratioh,
                                  float ratiod)

  Overrides:
    `setTex3DCoords` in class `ShadowType`

### setTexStackCoords

    public float[] setTexStackCoords(int length,
                                     int axis,
                                     float ratiow,
                                     float ratioh,
                                     float ratiod)

  Overrides:
    `setTexStackCoords` in class `ShadowType`

### getTextMaps

    public Vector getTextMaps(int i,
                              int[] textIndices)

  Overrides:
    `getTextMaps` in class `ShadowType`

### textureToGroup

    public void textureToGroup(Object group,
                               VisADGeometryArray array,
                               BufferedImage image,
                               GraphicsModeControl mode,
                               float constant_alpha,
                               float[] constant_color,
                               int texture_width,
                               int texture_height)
                        throws VisADException

  Overrides:
    `textureToGroup` in class `ShadowType`
  Throws:
    `VisADException`

### texture3DToGroup

    public void texture3DToGroup(Object group,
                                 VisADGeometryArray arrayX,
                                 VisADGeometryArray arrayY,
                                 VisADGeometryArray arrayZ,
                                 VisADGeometryArray arrayXrev,
                                 VisADGeometryArray arrayYrev,
                                 VisADGeometryArray arrayZrev,
                                 BufferedImage[] images,
                                 GraphicsModeControl mode,
                                 float constant_alpha,
                                 float[] constant_color,
                                 int texture_width,
                                 int texture_height,
                                 int texture_depth,
                                 DataRenderer renderer)
                          throws VisADException

  Overrides:
    `texture3DToGroup` in class `ShadowType`
  Throws:
    `VisADException`

### textureStackToGroup

    public void textureStackToGroup(Object group,
                                    VisADGeometryArray arrayX,
                                    VisADGeometryArray arrayY,
                                    VisADGeometryArray arrayZ,
                                    VisADGeometryArray arrayXrev,
                                    VisADGeometryArray arrayYrev,
                                    VisADGeometryArray arrayZrev,
                                    BufferedImage[] imagesX,
                                    BufferedImage[] imagesY,
                                    BufferedImage[] imagesZ,
                                    GraphicsModeControl mode,
                                    float constant_alpha,
                                    float[] constant_color,
                                    int texture_width,
                                    int texture_height,
                                    int texture_depth,
                                    DataRenderer renderer)
                             throws VisADException

  Overrides:
    `textureStackToGroup` in class `ShadowType`
  Throws:
    `VisADException`

### makeGeometrys

    public javax.media.j3d.GeometryArray[] makeGeometrys(VisADGeometryArray array)
                                                  throws VisADException

  Throws:
    `VisADException`

### makeVisADGeometrys

    public VisADGeometryArray[] makeVisADGeometrys(VisADGeometryArray array)
                                            throws VisADException

  Throws:
    `VisADException`

### makeSwitch

    public Object makeSwitch()

  Overrides:
    `makeSwitch` in class `ShadowType`

### makeBranch

    public Object makeBranch()

  Overrides:
    `makeBranch` in class `ShadowType`

### addToGroup

    public void addToGroup(Object group,
                           Object branch)
                    throws VisADException

  Overrides:
    `addToGroup` in class `ShadowType`
  Throws:
    `VisADException`

### addToSwitch

    public void addToSwitch(Object swit,
                            Object branch)
                     throws VisADException

  Overrides:
    `addToSwitch` in class `ShadowType`
  Throws:
    `VisADException`

### addSwitch

    public void addSwitch(Object group,
                          Object swit,
                          Control control,
                          Set domain_set,
                          DataRenderer renderer)
                   throws VisADException

  Overrides:
    `addSwitch` in class `ShadowType`
  Throws:
    `VisADException`

### recurseRange

    public boolean recurseRange(Object group,
                                Data data,
                                float[] value_array,
                                float[] default_values,
                                DataRenderer renderer)
                         throws VisADException,
                                RemoteException

  Overrides:
    `recurseRange` in class `ShadowType`
  Throws:
    `VisADException`
    `RemoteException`

### wantIndexed

    public boolean wantIndexed()

  Overrides:
    `wantIndexed` in class `ShadowType`

### postProcess

    public void postProcess(Object group)
                     throws VisADException

  render accumulated Vector of value_array-s to and add to group; then clear AccumulationVector

  Overrides:
    `postProcess` in class `ShadowTypeJ3D`
  Throws:
    `VisADException`